#include <iostream>
#include <cstdlib>
#include <cmath>

int main (int argc, char * const argv[]) {

    int a, b , c , d ;
    int a_10, b_10, c_10, d_10;
	int a_8, b_8, c_8, d_8;
    int all_8, all_10, all_14;
	
	long err0, err1, err2, err3; 
    
	err0= err1= err2= err3= 0;
  	srand (time(NULL));
	
	for (int i=0; i<10000000; i++)
	{
		a = rand() % 16384 ;
		b = rand() % 16384  ;
		c = rand() % 16384  ;
		d = rand() % 16384  ;
	
	a_10 = a/16;
	b_10 = b/16;
	c_10 = c/16;
	d_10 = d/16;
	
	all_10 = (a_10+ b_10+ c_10+ d_10)/4;  // Ein Downscale-Sample aus 4 x 10 Bit
	
	a_8 = a/64;
	b_8 = b/64;
	c_8 = c/64;
	d_8 = d/64;
	
    all_8 = (a_8+ b_8+ c_8+ d_8) + 1; // Ein 10 Bit Sample aus 4 x 8 Bit
		                                  // + 1 Korrekturfaktor
                                      
		if  (all_8 == all_10)           err0++;   //Treffer
		if  (abs (all_10 - all_8) == 1) err1++;   //+-1 daneben
		if  (abs (all_10 - all_8) == 2) err2++;   //schwer daneben
		if  (abs (all_10 - all_8) == 3) err3++;   //...
	}
	  
    std::cout << "Abweichung 2x2 8 Bit - 10 Bit \n\n";
    std::cout << "err0: " << err0 << "\n";
	std::cout << "err1: " << err1 << "\n";
	std::cout << "err2: " << err2 << "\n";
	std::cout << "err3: " << err3 << "\n";
    std::cout << "Einbezogene Samples: " << err0 + err1 + err2 + err3 << "\n\n";

    return 0;
}
